"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _TimePicker = _interopRequireDefault(require("carbon-components-react/lib/components/TimePicker/TimePicker.js"));

var _TimePickerSelect = _interopRequireDefault(require("carbon-components-react/lib/components/TimePickerSelect/TimePickerSelect.js"));

var _SelectItem = _interopRequireDefault(require("carbon-components-react/lib/components/SelectItem/SelectItem.js"));

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var _helperTextBlock = _interopRequireDefault(require("../helper-text-block/helper-text-block"));

var TimePicker = function TimePicker(props) {
  var _timezones$;

  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(props)),
      input = _useFieldApi.input,
      meta = _useFieldApi.meta,
      twelveHoursFormat = _useFieldApi.twelveHoursFormat,
      timezones = _useFieldApi.timezones,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      WrapperProps = _useFieldApi.WrapperProps,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, ["input", "meta", "twelveHoursFormat", "timezones", "validateOnMount", "helperText", "WrapperProps"]);

  var _useState = (0, _react.useState)(timezones ? (_timezones$ = timezones[0]) === null || _timezones$ === void 0 ? void 0 : _timezones$.value : ''),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      timezone = _useState2[0],
      selectTimezone = _useState2[1];

  var _useState3 = (0, _react.useState)('AM'),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      format = _useState4[0],
      selectFormat = _useState4[1];

  var isMounted = (0, _react.useRef)(false);
  var invalid = (meta.touched || validateOnMount) && (meta.error || meta.submitError);
  var warnText = (meta.touched || validateOnMount) && meta.warning;
  var finalValue = input.value;

  if (input.value instanceof Date) {
    var _timezones$find;

    var _input$value$toLocale = input.value.toLocaleTimeString('en-us', {
      hour12: !!twelveHoursFormat,
      timeZone: timezones === null || timezones === void 0 ? void 0 : (_timezones$find = timezones.find(function (_ref) {
        var value = _ref.value;
        return value === timezone;
      })) === null || _timezones$find === void 0 ? void 0 : _timezones$find.showAs
    }).split(':'),
        _input$value$toLocale2 = (0, _slicedToArray2["default"])(_input$value$toLocale, 2),
        _input$value$toLocale3 = _input$value$toLocale2[0],
        hours = _input$value$toLocale3 === void 0 ? '00' : _input$value$toLocale3,
        _input$value$toLocale4 = _input$value$toLocale2[1],
        minutes = _input$value$toLocale4 === void 0 ? '00' : _input$value$toLocale4;

    finalValue = "".concat(String(hours).padStart(2, '0'), ":").concat(String(minutes).padStart(2, '0'));
  }

  var enhnancedOnBlur = function enhnancedOnBlur() {
    var _finalValue;

    var _ref2 = ((_finalValue = finalValue) === null || _finalValue === void 0 ? void 0 : _finalValue.split(':')) || [],
        _ref3 = (0, _slicedToArray2["default"])(_ref2, 2),
        _ref3$ = _ref3[0],
        hours = _ref3$ === void 0 ? '00' : _ref3$,
        _ref3$2 = _ref3[1],
        minutes = _ref3$2 === void 0 ? '00' : _ref3$2;

    if (!hours || isNaN(hours)) {
      hours = '00';
    }

    if (!minutes || isNaN(minutes)) {
      minutes = '00';
    }

    if (twelveHoursFormat) {
      hours = hours % 12;

      if (format === 'PM') {
        hours = hours + 12;
      }
    } else {
      hours = hours % 24;
    }

    minutes = minutes % 59;
    var enhancedValue = new Date("Jan 1 2000 ".concat(hours, ":").concat(minutes, ":00 ").concat(timezone));
    input.onChange(enhancedValue);
    input.onBlur();
  };

  (0, _react.useEffect)(function () {
    if (isMounted.current === true) {
      enhnancedOnBlur();
    } else {
      isMounted.current = true;
    }
  }, [timezone, format]);
  return /*#__PURE__*/_react["default"].createElement("div", WrapperProps, /*#__PURE__*/_react["default"].createElement(_TimePicker["default"], (0, _extends2["default"])({}, input, {
    value: finalValue,
    onBlur: enhnancedOnBlur,
    key: input.name,
    id: input.name,
    invalid: Boolean(invalid),
    invalidText: invalid || ''
  }, rest), twelveHoursFormat && /*#__PURE__*/_react["default"].createElement(_TimePickerSelect["default"], {
    labelText: "Period",
    id: "".concat(rest.id || input.name, "-12h"),
    onChange: function onChange(_ref4) {
      var value = _ref4.target.value;
      return selectFormat(value);
    }
  }, /*#__PURE__*/_react["default"].createElement(_SelectItem["default"], {
    value: "AM",
    text: "AM"
  }), /*#__PURE__*/_react["default"].createElement(_SelectItem["default"], {
    value: "PM",
    text: "PM"
  })), timezones && /*#__PURE__*/_react["default"].createElement(_TimePickerSelect["default"], {
    labelText: "Timezone",
    id: "".concat(rest.id || input.name, "-timezones"),
    onChange: function onChange(_ref5) {
      var value = _ref5.target.value;
      return selectTimezone(value);
    }
  }, timezones.map(function (_ref6) {
    var showAs = _ref6.showAs,
        tz = (0, _objectWithoutProperties2["default"])(_ref6, ["showAs"]);
    return /*#__PURE__*/_react["default"].createElement(_SelectItem["default"], (0, _extends2["default"])({
      key: tz.value,
      text: tz.label
    }, tz));
  }))), /*#__PURE__*/_react["default"].createElement(_helperTextBlock["default"], {
    helperText: !invalid && helperText,
    warnText: warnText
  }));
};

TimePicker.propTypes = {
  isDisabled: _propTypes["default"].bool,
  isReadOnly: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  label: _propTypes["default"].node,
  labelText: _propTypes["default"].node,
  description: _propTypes["default"].node,
  twelveHoursFormat: _propTypes["default"].bool,
  timezones: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].string.isRequired,
    label: _propTypes["default"].node.isRequired,
    showAs: _propTypes["default"].string.isRequired
  })),
  WrapperProps: _propTypes["default"].object
};
var _default = TimePicker;
exports["default"] = _default;